# $Id: infra.py 1061 2009-03-31 15:35:03Z wsl $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/trunk/sources/meresco/bzv-2.4.0/src/infra.py $
import os
import logging
import logging.config
import pprint
import sys

class Infra:
    def __init__(self,startupMessage,loggingConfigfile):
        self.loggingConfigfile = loggingConfigfile
        self._prettyPrint()
        self._startLogging(startupMessage)

    def _getEnvironment(self):
        prefix = os.environ.get("prefix")
        if not prefix:
            prefix = '.'
            sys.stderr.write ('Environment variable: PREFIX not set, using:"' + prefix + '"') #
        self.prefix = prefix
        self.sysconfdir = prefix = prefix + '/etc'

    def _startLogging(self,startupMessage):
        self.logging=logging
        try:
            logging.config.fileConfig(self.loggingConfigfile)

        except Exception, e:
            sys.stderr.write ('Could not parse loggingConfigfile: "' + self.loggingConfigfile + '"')

        logging.info(startupMessage)

    def _prettyPrint(self):
        self.pp = pprint.PrettyPrinter(indent=2)

    def prpt(self, label, param):
        return label + "\n" + self.pp.pformat(param)

    def dd(self, label, param):
        #debug dump
        self.logging.debug(self.prpt(label, param))

    def d(self, param):
        #short for debug
        self.logging.debug(param)


    def getLoggingInstance(self):
        return self.logging

#    def addConfigParser(self, configParserName,configParserInstance):
#        self.configParserName=configParserInstance
